<?php
namespace Geral\Repositories;

class Precobase extends \Doctrine\ORM\EntityRepository
{

    public function getPrecoBase($cdcliente, $cdvendedor, $cdmodpgto, $cdvendeaux, $cdmodpgtoaux){
        try{
            $sql =" SELECT *
					  FROM (SELECT CDPRECOBASE, DSPRECOBASE, IDPESQ
							  FROM (SELECT PB.CDPRECOBASE, PB.DSPRECOBASE, '1' IDPESQ
									  FROM PRECOBASE PB, PRECOBASECLI PC
									 WHERE PB.CDPRECOBASE IN (SELECT DISTINCT CDPRECOBASE
																FROM PRECOBASECLI
															   WHERE CDCLIENTE = :P_CDCLIENTE)
																 AND (PC.CDPRECOBASE  = PB.CDPRECOBASE)
																 AND (PC.CDCLIENTE    = :P_CDCLIENTE)
																 AND (PC.IDPRBASEPRIN = 'S')

									 UNION

									SELECT P.CDPRECOBASE, P.DSPRECOBASE, '2' IDPESQ
									  FROM PRECOBASE P, VENDEDOR V
									 WHERE (P.CDPRECOBASE = V.CDPRECOBASE)
									   AND (V.CDVENDEDOR  = :P_CDVENDEDOR)
									   AND P.CDPRECOBASE IN (SELECT DISTINCT CDPRECOBASE
															   FROM PRECOBASECLI
															  WHERE CDCLIENTE = :P_CDCLIENTE)

									 UNION

									SELECT P.CDPRECOBASE, P.DSPRECOBASE, '3' IDPESQ
									  FROM PRECOBASE P, VENDEDOR V
									 WHERE (P.CDPRECOBASE = V.CDPRECOBASE)
									   AND (V.CDVENDEDOR  = :P_CDVENDEDOR)
									   AND (:P_CDCLIENTE IS NULL)

									UNION

									SELECT PB.CDPRECOBASE, PB.DSPRECOBASE, '4' IDPESQ
									  FROM PRECOBASE PB, PRECOUTI PC
									 WHERE (PB.CDPRECOBASE = PC.CDPRECOBASE)
									   AND (PC.CDMODPGTO   = :P_CDMODPGTO)
									   AND PB.CDPRECOBASE IN (SELECT DISTINCT CDPRECOBASE
																FROM PRECOBASECLI
															   WHERE CDCLIENTE = :P_CDCLIENTE)

									UNION

									SELECT PB.CDPRECOBASE, PB.DSPRECOBASE, '5' IDPESQ
									  FROM PRECOBASE PB, PRECOUTI PC
									 WHERE (PB.CDPRECOBASE = PC.CDPRECOBASE)
									   AND (PC.CDMODPGTO   = :P_CDMODPGTO)
									   AND (:P_CDCLIENTE IS NULL)

									 UNION

									SELECT P.CDPRECOBASE, P.DSPRECOBASE, '6' IDPESQ
									  FROM PRECOBASE P, VENDEDOR V
									 WHERE (P.CDPRECOBASE = V.CDPRECOBASE)
									   AND (V.CDVENDEDOR  = :P_CDVENDEAUX)
									   AND (:P_CDCLIENTE IS NOT NULL)

									 UNION

									SELECT PB.CDPRECOBASE, PB.DSPRECOBASE, '7' IDPESQ
									  FROM PRECOBASE PB, PRECOUTI PC
									 WHERE (PB.CDPRECOBASE = PC.CDPRECOBASE)
									   AND (PC.CDMODPGTO   = :P_MODPGTOAUX)
									   AND (:P_CDCLIENTE  IS NOT NULL)
									   AND (:P_CDVENDEAUX IS NOT NULL))
						  ORDER BY IDPESQ)
					 WHERE ROWNUM = 1";
            $params = array(
                'P_CDCLIENTE'  => $cdcliente,
                'P_CDVENDEDOR' => $cdvendedor,
                'P_CDMODPGTO'  => $cdmodpgto,
                'P_CDVENDEAUX' => $cdvendeaux,
                'P_MODPGTOAUX' => $cdmodpgtoaux
            );

            return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

        }catch(\Exception $e){
            throw $e;
        }
    }
	
	public function getMaiorCodigoPrecoBase($nrorg){
		try{
			$sql = "SELECT NVL(MAX(CDPRECOBASE) + 1, 1) CDPRECOBASE
					  FROM PRECOBASE
					 WHERE NRORG = :P_NRORG";
			$params = array("P_NRORG" => $nrorg);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
		}catch(\Exception $e){
			throw $e;
		}
	}
}