<?php
namespace Teknisa\Model\Teknisa\Entities;

use Teknisa\Model\Teknisa\Events\AuditAble;
use Teknisa\Model\Teknisa\Events\GeneratesNewCode;

class CpCall extends Base\CpCall implements GeneratesNewCode,AuditAble{

    const TYPE_ISSUE        = 'I';   /* issue - PM */
    const TYPE_RICH_CLIENT  = 'S';   /* solicitação */
    const TYPE_TICKET       = 'T';   /* Ticket ServiceDesk */
    const TYPE_CASO         = 'C';   /* caso - CRM */

    const TYPE_ISSUE_DESC        = 'Produto (Zeedhi: App, Browser, Mobile)';
    const TYPE_RICH_CLIENT_DESC  = 'Produto (Delphi: Windows)';
    const TYPE_TICKET_DESC       = 'Requisição de Mudança';
    const TYPE_CASO_DESC         = 'Suporte';

    const OPEN_SITUATION = "O";
    const PROGRESS_SITUATION  = "P";
    const CLOSE_SITUATION  = "C";
    const WAITING_SPONSOR_SITUATION  = "W";

    public function setPrimaryKeyInPersist($newCode){
        if($this->getCallRelationship() && $this->getType() == "T") {
            $newCode = $this->getCallRelationship();
        }
        $this->setNrcall(intval($newCode));
    }

    public function setDtconpcuren(\Datetime $dtconpcuren = NULL) {
        parent::setDtconpcuren($dtconpcuren);
        if(empty($this->getDtconpinit()) && !empty($dtconpcuren)){
            $this->setDtconpinit($dtconpcuren);
        }
    }

}
